
var dlgSetting = {
	
	get STRING()   { return document.getElementById("bitsHyperAnchorString"); },
	get PREVIEW() { return document.getElementById("dlgSettingPreview"); },
	
	init : function(){
	
		document.documentElement.buttons = "accept,cancel";
		
		// Default Style
		var defaultStyle = nsPreferences.copyUnicharPref("hyperanchor.dlgSetting.defaultStyle", this.STRING.getString("DEFAULT_STYLE"));
		this.parseFromString(defaultStyle);
		
		// Adapt this style to all anchor.
		var adaptDefaultStyle2Plain = nsPreferences.copyUnicharPref("hyperanchor.dlgSetting.adaptDefultStyle2Plain", this.STRING.getString("ADAPT_DEFAULT_STYLE_2_PLAIN"));
		document.getElementById("markerAdaptDefultStyle2Plain").checked = adaptDefaultStyle2Plain.toLowerCase() == "true" ? true : false;
		
		// Check hyperanchor format on browsing.
		var execValidation = nsPreferences.copyUnicharPref("hyperanchor.dlgSetting.execValidation", this.STRING.getString("EXEC_VALIDATION"));
		document.getElementById("markerExecValidation").checked = execValidation.toLowerCase() == "true" ? true : false;
		
		// Marked Up String Mapping Margin Initialize.
		var mappingMargin = nsPreferences.copyUnicharPref("hyperanchor.dlgSetting.mappingMargin", this.STRING.getString("MAPPING_MARGIN"));
		document.getElementById("mappingMargin").value = mappingMargin;
		
		// Shortcut Key Setting Initialize for Bookmark.
		var shortcut_bookmark_accel = nsPreferences.copyUnicharPref("hyperanchor.dlgSetting.shortcut_bookmark_accel", this.STRING.getString("SHORTCUT_BOOKMARK_ACCEL"));
		document.getElementById("shortcut_bookmark_accel").checked = shortcut_bookmark_accel.toLowerCase() == "true" ? true : false;

		var shortcut_bookmark_shift = nsPreferences.copyUnicharPref("hyperanchor.dlgSetting.shortcut_bookmark_shift", this.STRING.getString("SHORTCUT_BOOKMARK_SHIFT"));
		document.getElementById("shortcut_bookmark_shift").checked = shortcut_bookmark_shift.toLowerCase() == "true" ? true : false;
		
		var shortcut_bookmark_alt = nsPreferences.copyUnicharPref("hyperanchor.dlgSetting.shortcut_bookmark_alt", this.STRING.getString("SHORTCUT_BOOKMARK_ALT"));
		document.getElementById("shortcut_bookmark_alt").checked = shortcut_bookmark_alt.toLowerCase() == "true" ? true : false;
		
		var shortcut_bookmark_char = nsPreferences.copyUnicharPref("hyperanchor.dlgSetting.shortcut_bookmark_char", this.STRING.getString("SHORTCUT_BOOKMARK_CHAR"));
		var menuitems = document.getElementById("shortcut_bookmark_char").getElementsByTagName("menuitem");
		for(var i = 0; i < menuitems.length; i++){
			if(menuitems[i].value == shortcut_bookmark_char){
				document.getElementById("shortcut_bookmark_char").selectedIndex = i;
				break;
			}
		}
		
		// Shortcut Key Setting Initialize for Clipboard.
		var shortcut_clipboard_accel = nsPreferences.copyUnicharPref("hyperanchor.dlgSetting.shortcut_clipboard_accel", this.STRING.getString("SHORTCUT_CLIPBOARD_ACCEL"));
		document.getElementById("shortcut_clipboard_accel").checked = shortcut_clipboard_accel.toLowerCase() == "true" ? true : false;

		var shortcut_clipboard_shift = nsPreferences.copyUnicharPref("hyperanchor.dlgSetting.shortcut_clipboard_shift", this.STRING.getString("SHORTCUT_CLIPBOARD_SHIFT"));
		document.getElementById("shortcut_clipboard_shift").checked = shortcut_clipboard_shift.toLowerCase() == "true" ? true : false;
		
		var shortcut_clipboard_alt = nsPreferences.copyUnicharPref("hyperanchor.dlgSetting.shortcut_clipboard_alt", this.STRING.getString("SHORTCUT_CLIPBOARD_ALT"));
		document.getElementById("shortcut_clipboard_alt").checked = shortcut_clipboard_alt.toLowerCase() == "true" ? true : false;
		
		var shortcut_clipboard_char = nsPreferences.copyUnicharPref("hyperanchor.dlgSetting.shortcut_clipboard_char", this.STRING.getString("SHORTCUT_CLIPBOARD_CHAR"));
		var menuitems = document.getElementById("shortcut_clipboard_char").getElementsByTagName("menuitem");
		for(var i = 0; i < menuitems.length; i++){
			if(menuitems[i].value == shortcut_clipboard_char){
				document.getElementById("shortcut_clipboard_char").selectedIndex = i;
				break;
			}
		}
		
		// Shortcut Key Setting Initialize for Clipboard.
		var shortcut_clipboard_text_accel = nsPreferences.copyUnicharPref("hyperanchor.dlgSetting.shortcut_clipboard_text_accel", this.STRING.getString("SHORTCUT_CLIPBOARD_TEXT_ACCEL"));
		document.getElementById("shortcut_clipboard_text_accel").checked = shortcut_clipboard_text_accel.toLowerCase() == "true" ? true : false;

		var shortcut_clipboard_text_shift = nsPreferences.copyUnicharPref("hyperanchor.dlgSetting.shortcut_clipboard_text_shift", this.STRING.getString("SHORTCUT_CLIPBOARD_TEXT_SHIFT"));
		document.getElementById("shortcut_clipboard_text_shift").checked = shortcut_clipboard_text_shift.toLowerCase() == "true" ? true : false;
		
		var shortcut_clipboard_text_alt = nsPreferences.copyUnicharPref("hyperanchor.dlgSetting.shortcut_clipboard_text_alt", this.STRING.getString("SHORTCUT_CLIPBOARD_TEXT_ALT"));
		document.getElementById("shortcut_clipboard_text_alt").checked = shortcut_clipboard_text_alt.toLowerCase() == "true" ? true : false;
		
		var shortcut_clipboard_text_char = nsPreferences.copyUnicharPref("hyperanchor.dlgSetting.shortcut_clipboard_text_char", this.STRING.getString("SHORTCUT_CLIPBOARD_TEXT_CHAR"));
		var menuitems = document.getElementById("shortcut_clipboard_text_char").getElementsByTagName("menuitem");
		for(var i = 0; i < menuitems.length; i++){
			if(menuitems[i].value == shortcut_clipboard_text_char){
				document.getElementById("shortcut_clipboard_text_char").selectedIndex = i;
				break;
			}
		}
		
		// Shortcut Key Setting Initialize for Reload.
		var shortcut_reload_accel = nsPreferences.copyUnicharPref("hyperanchor.dlgSetting.shortcut_reload_accel", this.STRING.getString("SHORTCUT_RELOAD_ACCEL"));
		document.getElementById("shortcut_reload_accel").checked = shortcut_reload_accel.toLowerCase() == "true" ? true : false;

		var shortcut_reload_shift = nsPreferences.copyUnicharPref("hyperanchor.dlgSetting.shortcut_reload_shift", this.STRING.getString("SHORTCUT_RELOAD_SHIFT"));
		document.getElementById("shortcut_reload_shift").checked = shortcut_reload_shift.toLowerCase() == "true" ? true : false;
		
		var shortcut_reload_alt = nsPreferences.copyUnicharPref("hyperanchor.dlgSetting.shortcut_reload_alt", this.STRING.getString("SHORTCUT_RELOAD_ALT"));
		document.getElementById("shortcut_reload_alt").checked = shortcut_reload_alt.toLowerCase() == "true" ? true : false;
		
		var shortcut_reload_char = nsPreferences.copyUnicharPref("hyperanchor.dlgSetting.shortcut_reload_char", this.STRING.getString("SHORTCUT_RELOAD_CHAR"));
		var menuitems = document.getElementById("shortcut_reload_char").getElementsByTagName("menuitem");
		for(var i = 0; i < menuitems.length; i++){
			if(menuitems[i].value == shortcut_reload_char){
				document.getElementById("shortcut_reload_char").selectedIndex = i;
				break;
			}
		}
		
		// Shortcut Key Setting Initialize for Clear.
		var shortcut_clear_accel = nsPreferences.copyUnicharPref("hyperanchor.dlgSetting.shortcut_clear_accel", this.STRING.getString("SHORTCUT_CLEAR_ACCEL"));
		document.getElementById("shortcut_clear_accel").checked = shortcut_clear_accel.toLowerCase() == "true" ? true : false;

		var shortcut_clear_shift = nsPreferences.copyUnicharPref("hyperanchor.dlgSetting.shortcut_clear_shift", this.STRING.getString("SHORTCUT_CLEAR_SHIFT"));
		document.getElementById("shortcut_clear_shift").checked = shortcut_clear_shift.toLowerCase() == "true" ? true : false;
		
		var shortcut_clear_alt = nsPreferences.copyUnicharPref("hyperanchor.dlgSetting.shortcut_clear_alt", this.STRING.getString("SHORTCUT_CLEAR_ALT"));
		document.getElementById("shortcut_clear_alt").checked = shortcut_clear_alt.toLowerCase() == "true" ? true : false;
		
		var shortcut_clear_char = nsPreferences.copyUnicharPref("hyperanchor.dlgSetting.shortcut_clear_char", this.STRING.getString("SHORTCUT_CLEAR_CHAR"));
		var menuitems = document.getElementById("shortcut_clear_char").getElementsByTagName("menuitem");
		for(var i = 0; i < menuitems.length; i++){
			if(menuitems[i].value == shortcut_clear_char){
				document.getElementById("shortcut_clear_char").selectedIndex = i;
				break;
			}
		}
		
		// Context menu setting
		var contextmenu_display_bookmark = nsPreferences.getBoolPref("hyperanchor.dlgSetting.contextmenu_display_bookmark", true);
		document.getElementById("contextmenu_display_bookmark").checked = contextmenu_display_bookmark;
		
		var contextmenu_display_clipboard = nsPreferences.getBoolPref("hyperanchor.dlgSetting.contextmenu_display_clipboard", true);
		document.getElementById("contextmenu_display_clipboard").checked = contextmenu_display_clipboard;
		
		var contextmenu_display_clipboard_text = nsPreferences.getBoolPref("hyperanchor.dlgSetting.contextmenu_display_clipboard_text", true);
		document.getElementById("contextmenu_display_clipboard_text").checked = contextmenu_display_clipboard_text;
		
		var contextmenu_display_stylesetting = nsPreferences.getBoolPref("hyperanchor.dlgSetting.contextmenu_display_stylesetting", true);
		document.getElementById("contextmenu_display_stylesetting").checked = contextmenu_display_stylesetting;
		
		var contextmenu_display_hasetting = nsPreferences.getBoolPref("hyperanchor.dlgSetting.contextmenu_display_hasetting", true);
		document.getElementById("contextmenu_display_hasetting").checked = contextmenu_display_hasetting;
		
		if(window.arguments && window.arguments[0] == 'dlgCalled' && window.opener.bitsHyperAnchor) window.opener.bitsHyperAnchor._dlgCalled = true;
		
	},

	done : function(){
		// Default Style
		nsPreferences.setUnicharPref("hyperanchor.dlgSetting.defaultStyle", this.parseToString(false));

		// Adapt this style to all anchor.
		nsPreferences.setUnicharPref("hyperanchor.dlgSetting.adaptDefultStyle2Plain", document.getElementById("markerAdaptDefultStyle2Plain").checked);

		// Check hyperanchor format on browsing.
		nsPreferences.setUnicharPref("hyperanchor.dlgSetting.execValidation", document.getElementById("markerExecValidation").checked);

		// Marked Up String Mapping Margin Save.
		nsPreferences.setUnicharPref("hyperanchor.dlgSetting.mappingMargin", document.getElementById("mappingMargin").value);
		
		// Shortcut Key Setting Save for Bookmark.
		nsPreferences.setUnicharPref("hyperanchor.dlgSetting.shortcut_bookmark_accel", document.getElementById("shortcut_bookmark_accel").checked);
		nsPreferences.setUnicharPref("hyperanchor.dlgSetting.shortcut_bookmark_shift", document.getElementById("shortcut_bookmark_shift").checked);
		nsPreferences.setUnicharPref("hyperanchor.dlgSetting.shortcut_bookmark_alt", document.getElementById("shortcut_bookmark_alt").checked);
		nsPreferences.setUnicharPref("hyperanchor.dlgSetting.shortcut_bookmark_char", document.getElementById("shortcut_bookmark_char").value);
		
		// Shortcut Key Setting Save for Clipboard.
		nsPreferences.setUnicharPref("hyperanchor.dlgSetting.shortcut_clipboard_accel", document.getElementById("shortcut_clipboard_accel").checked);
		nsPreferences.setUnicharPref("hyperanchor.dlgSetting.shortcut_clipboard_shift", document.getElementById("shortcut_clipboard_shift").checked);
		nsPreferences.setUnicharPref("hyperanchor.dlgSetting.shortcut_clipboard_alt", document.getElementById("shortcut_clipboard_alt").checked);
		nsPreferences.setUnicharPref("hyperanchor.dlgSetting.shortcut_clipboard_char", document.getElementById("shortcut_clipboard_char").value);
		
		// Shortcut Key Setting Save for Reload.
		nsPreferences.setUnicharPref("hyperanchor.dlgSetting.shortcut_reload_accel", document.getElementById("shortcut_reload_accel").checked);
		nsPreferences.setUnicharPref("hyperanchor.dlgSetting.shortcut_reload_shift", document.getElementById("shortcut_reload_shift").checked);
		nsPreferences.setUnicharPref("hyperanchor.dlgSetting.shortcut_reload_alt", document.getElementById("shortcut_reload_alt").checked);
		nsPreferences.setUnicharPref("hyperanchor.dlgSetting.shortcut_reload_char", document.getElementById("shortcut_reload_char").value);
		
		// Shortcut Key Setting Save for Clear.
		nsPreferences.setUnicharPref("hyperanchor.dlgSetting.shortcut_clear_accel", document.getElementById("shortcut_clear_accel").checked);
		nsPreferences.setUnicharPref("hyperanchor.dlgSetting.shortcut_clear_shift", document.getElementById("shortcut_clear_shift").checked);
		nsPreferences.setUnicharPref("hyperanchor.dlgSetting.shortcut_clear_alt", document.getElementById("shortcut_clear_alt").checked);
		nsPreferences.setUnicharPref("hyperanchor.dlgSetting.shortcut_clear_char", document.getElementById("shortcut_clear_char").value);
		
		// Context menu setting
		nsPreferences.setBoolPref("hyperanchor.dlgSetting.contextmenu_display_bookmark", document.getElementById("contextmenu_display_bookmark").checked);
		nsPreferences.setBoolPref("hyperanchor.dlgSetting.contextmenu_display_clipboard", document.getElementById("contextmenu_display_clipboard").checked);
		nsPreferences.setBoolPref("hyperanchor.dlgSetting.contextmenu_display_clipboard_text", document.getElementById("contextmenu_display_clipboard_text").checked);
		nsPreferences.setBoolPref("hyperanchor.dlgSetting.contextmenu_display_stylesetting", document.getElementById("contextmenu_display_stylesetting").checked);
		nsPreferences.setBoolPref("hyperanchor.dlgSetting.contextmenu_display_hasetting", document.getElementById("contextmenu_display_hasetting").checked);
		
		if(window.opener.bitsHyperAnchor){
			window.opener.bitsHyperAnchor.setShortcutKey();
			window.opener.bitsHyperAnchor._reload();
		}
	},

	update : function(){
		this.PREVIEW.setAttribute("style", this.parseToString(true));
	},

	broadcast : function(){
		var ret = [
			document.getElementById("markerBackgroundEnabled").checked,
			document.getElementById("markerTextEnabled").checked,
			document.getElementById("markerBorderEnabled").checked,
			document.getElementById("markerIconEnabled").checked
		];
		document.getElementById("markerBroadcast0").setAttribute("disabled", !ret[0]);
		document.getElementById("markerBroadcast1").setAttribute("disabled", !ret[1]);
		document.getElementById("markerBroadcast2").setAttribute("disabled", !ret[2]);
		document.getElementById("markerBroadcast3").setAttribute("disabled", !ret[3]);
		return ret;
	},

	parseFromString : function(cssText){
		this.PREVIEW.setAttribute("style", cssText);
		document.getElementById("markerTextBold").checked          = this.PREVIEW.style.fontWeight == "bold";
		document.getElementById("markerTextItalic").checked        = this.PREVIEW.style.fontStyle == "italic";
		document.getElementById("markerTextStrike").checked        = this.PREVIEW.style.textDecoration == "line-through";
		document.getElementById("markerBackgroundEnabled").checked = this.PREVIEW.style.backgroundColor;
		document.getElementById("markerTextEnabled").checked       = this.PREVIEW.style.color;
		document.getElementById("markerBorderEnabled").checked     = this.PREVIEW.style.borderBottom;
		var iconInfo = this.getIconStyle(cssText);
		document.getElementById("markerIconEnabled").checked = iconInfo["iconEnabled"];

		var bcList = this.broadcast();
		if(bcList[0]) document.getElementById("markerBackgroundColor").color = this.PREVIEW.style.backgroundColor;
		if(bcList[1]) document.getElementById("markerTextColor").color       = this.PREVIEW.style.color;
		if(bcList[2]){
			document.getElementById("markerBorderColor").color = this.PREVIEW.style.borderBottomColor;
			document.getElementById("markerBorderType").selectedIndex = this.PREVIEW.style.borderTop ? 0 : 1;
//			var elem = document.getElementsByAttribute("value", this.PREVIEW.style.borderBottomStyle);
//			document.getElementById("markerBorderStyle").selectedIndex = elem.length > 0 ? elem[0].getAttribute("index") : 0;
//			elem = document.getElementsByAttribute("value", this.PREVIEW.style.borderBottomWidth);
//			document.getElementById("markerBorderWidth").selectedIndex = elem.length > 0 ? elem[0].getAttribute("index") : 0;
			document.getElementById("markerBorderStyle").selectedIndex = 
				this.getMenulistSelectedIndex("markerBorderStyle", this.PREVIEW.style.borderBottomStyle);
			document.getElementById("markerBorderWidth").selectedIndex = 
				this.getMenulistSelectedIndex("markerBorderWidth", this.PREVIEW.style.borderBottomWidth);
		}
		if(bcList[3]){
			var elem = null;
			document.getElementById("iconPos").selectedIndex 			= iconInfo["iconPos"];
			document.getElementById("imageType").selectedIndex 			= iconInfo["imageType"];
			document.getElementById("preparedIconURL").selectedIndex 	= iconInfo["preparedIconURLIndex"];
			document.getElementById("customIconWidth").selectedIndex 	= iconInfo["customIconWidthIndex"];
			document.getElementById("customIconURL").value 				= iconInfo["customIconURL"];
		}
	},

	getMenulistSelectedIndex : function(elemName, searchValue){
		var selectedIndex = 0;
		elem = document.getElementById(elemName).firstChild;
		for(var i = 0; i < elem.childNodes.length; i++){
			if(elem.childNodes[i].getAttribute("value") == searchValue){
				selectedIndex = elem.childNodes[i].getAttribute("index");
				break;
			}
		}
		return selectedIndex;
	},

	parseToString : function(isPreview){
		var bcList = this.broadcast();
		var cssRules = [];
		
		// Icon Group
		if(bcList[3]){
			// padding size
			var padSize = "16px";
			if(document.getElementById("imageType").selectedIndex == 0){
				padSize = "16px";
			}else{
				if(document.getElementById("customIconWidth").selectedItem != -1){
					padSize = document.getElementById("customIconWidth").selectedItem.value;
				}
			}
			// Icon Position
			// Left
			if(document.getElementById("iconPos").selectedIndex == 0){
				cssRules.push("padding-left:" + padSize);
			// Right
			}else{
				cssRules.push("padding-right:" + padSize);
			}
			// Background
			var background_str = "background:transparent scroll no-repeat ";
			if(document.getElementById("iconPos").selectedIndex == 0){
				background_str += "top left ";
			}else{
				background_str += "bottom right ";
			}
			// Icon URL
			// Prepared Icon
			if(document.getElementById("imageType").selectedIndex == 0){
				var preparedIconURLElem = document.getElementById("preparedIconURL").selectedItem;
				cssRules.push(background_str + "url(" + preparedIconURLElem.getAttribute("image") + ")");
			// Custom Icon
			}else if(document.getElementById("imageType").selectedIndex == 1){
				var customIconURLElem = document.getElementById("customIconURL");
				cssRules.push(background_str + "url(" + customIconURLElem.value + ")");
			// Other
			}else{
				cssRules.push(background_str + "url(http://)");
			}
		}
		
		// BackgroudColor Group
		if(bcList[0]){
			var backgroundColor = document.getElementById("markerBackgroundColor").color || "none";
			if(backgroundColor != "none") cssRules.push("background-color:" + backgroundColor);
		}
		
		// Text Group
		if(bcList[1]){
			var textColor = document.getElementById("markerTextColor").color || "none";
			if(textColor != "none") cssRules.push("color:" + textColor);
			if(document.getElementById("markerTextBold").checked)   cssRules.push("font-weight:bold");
			if(document.getElementById("markerTextItalic").checked) cssRules.push("font-style:italic");
			if(document.getElementById("markerTextStrike").checked) cssRules.push("text-decoration:line-through");
		}
		
		// Border Group
		if(bcList[2]){
			var borderType  = document.getElementById("markerBorderType").selectedItem.value == "box" ? "border" : "border-bottom";
			var borderStyle = document.getElementById("markerBorderStyle").selectedItem.value;
			var borderWidth = document.getElementById("markerBorderWidth").selectedItem.value;
			var borderColor = document.getElementById("markerBorderColor").color || "none";
			if(borderColor != "none") cssRules.push(borderType + ":" + [borderWidth,borderStyle,borderColor].join(" "));
		}
		
		var styleStr =  cssRules.join(";");
		styleStr += styleStr ? ";" : "";
		
		if(isPreview){
			styleStr = bitsHyperAnchor.convertURL2DataURL(styleStr);
		}
		return styleStr;
	},

	getIconStyle : function(cssText){
		var infoMap = new Array();
		var styles = cssText.split(';');

		for(var attrIdx = 0; attrIdx < styles.length; attrIdx++){
			var key_val = styles[attrIdx].split(':');
			
			if(key_val.length < 2) continue;
			
			var key = key_val[0];
			var val = key_val[1];
			for(var i = 2; i < key_val.length; i++){
				val += ":" + key_val[i];
			}
			key = this.trim(key);
			val = this.trim(val);
			if(key == "background"){
				infoMap["imageType"] = null;
				infoMap["preparedIconURLIndex"] = 0;
				infoMap["customIconURL"] = "";
				
				var URL = "";
				if(val.match(/url\(([\s\S]*?)\)/)){
					URL = RegExp.$1;
				}
				if(URL){
					var menuitems = document.getElementById("preparedIconURL").getElementsByTagName("menuitem");
					for(var i = 0; i < menuitems.length; i++){
						if(menuitems[i].getAttribute("image") == URL){
							infoMap["imageType"] = 0;
							infoMap["preparedIconURLIndex"] = i;
							break;
						}
					}
					if(infoMap["imageType"] == null && URL.length > 0){
						infoMap["imageType"] = 1;
						infoMap["customIconURL"] = URL;
					}
					infoMap["iconEnabled"] = true;
				}

			}else if(key == "padding-right"){
				infoMap["iconPos"]  = 1;
				var menuitems = document.getElementById("customIconWidth").getElementsByTagName("menuitem");
				for(var i = 0; i < menuitems.length; i++){
					if(menuitems[i].value == val){
						infoMap["customIconWidthIndex"] = i;
						break;
					}
				}

			}else if(key == "padding-left"){
				infoMap["iconPos"]  = 0;
				var menuitems = document.getElementById("customIconWidth").getElementsByTagName("menuitem");
				for(var i = 0; i < menuitems.length; i++){
					if(menuitems[i].value == val){
						infoMap["customIconWidthIndex"] = i;
						break;
					}
				}
			}
		}
		return infoMap;
	},

	trim : function(argValue){
		return String(argValue).replace(/^[ 　]*/gim, "").replace(/[ 　]*$/gim, "");
	},
	
	resetContextmenu : function(){
		
		document.getElementById("context-hyperanchor").setAttribute("hidden","true");
	},
	
};
